//--------------------------------------------------------------
// Alex A. Trubetskoy             January 2005
//--------------------------------------------------------------

#include "stdafx.h"
#include "AnchorData.h"

//--------------------------------------------------------------
//  
//--------------------------------------------------------------
CAnchor::CAnchor(CDialog* p): m_pDialog(p), old_x(0), old_y(0) {
	CRect r;

	m_pDialog->GetClientRect(&r);

	old_x = r.Width ();
	old_y = r.Height();
}

//--------------------------------------------------------------
//  
//--------------------------------------------------------------
CAnchor::~CAnchor() {
	for(UINT i = 0; i < anchors.size(); ++i) {
		if(anchors[i])
			delete anchors[i];
	}
}

//--------------------------------------------------------------
//  resize()
//    
//--------------------------------------------------------------
void CAnchor::resize()
{
    if(!m_pDialog)
        return;

    CRect r;

    m_pDialog->GetClientRect(&r);    //    

	if(!r.Width() || !r.Height())
		return;

    int dx = r.Width () - old_x;    //    
    int dy = r.Height() - old_y;    //  
	
	//   
	if(r.Width())
		old_x = r.Width ();             
	if(r.Height())
		old_y = r.Height();             

    HWND wnd;

    for(UINT i = 0; i < anchors.size(); ++i) {
        //   
        wnd = ::GetDlgItem(m_pDialog->m_hWnd, anchors[i]->id);

        ::GetWindowRect(wnd, &r);

        //      
        m_pDialog->ScreenToClient(&r);

        //   resizing  
        if( anchors[i]->left   ) r.left   += dx;
        if( anchors[i]->right  ) r.right  += dx;
        if( anchors[i]->top    ) r.top    += dy;  
        if( anchors[i]->bottom ) r.bottom += dy;

        //      
        ::MoveWindow(wnd, r.left, r.top, r.Width(), r.Height(), TRUE);
    }
}

//--------------------------------------------------------------
//  setAnchor()
//   ""  
//--------------------------------------------------------------
void CAnchor::setAnchor(UINT id, BOOL top, BOOL left, BOOL bottom, 
						BOOL right)
{
	SAnchorData* temp;

    temp = anchorByID(id);        //   ID   

    if(!temp)                     //   ,  
        temp = anchorAdd(id);

    //   
    temp->top    = !top;
    temp->left   = !left;
    temp->bottom = bottom;
    temp->right  = right;
}
//--------------------------------------------------------------
//  anchorByID()
//    ID   
//--------------------------------------------------------------
SAnchorData* CAnchor::anchorByID(int idx)
{
	for(UINT i = 0; i < anchors.size(); ++i) {
		if(anchors[i]->id == idx)
			return anchors[i];
	}
	return 0;
}
//--------------------------------------------------------------
//  anchorByID()
//     
//--------------------------------------------------------------
SAnchorData* CAnchor::anchorAdd(int idx)
{
	SAnchorData* pnew = new SAnchorData(idx);
	anchors.push_back(pnew);
	return pnew;
}
//--------------------------------------------------------------